#include <cassert>
#include <iostream>
#include <sstream>
#include <queue>
#include <map>
#include <algorithm>
#include <vector>
#include <set>
#define rep(i,a,b) for(int i=a;i<b;++i)
#define trav(it, v) for(typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)
#define MP(x,y) make_pair(x,y)
#define FI(x) (x).first
#define SE(x) (x).second
#define CR(x) const x&
#define PB push_back
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int,int> pii;
typedef vector<pii> vpii;
typedef map<int,pii> mipii;
typedef pair<vi,vi> pvivi;

vi bb(string s) {istringstream i(s); vi rt; int x; while(i >> x) rt.PB(x); return rt;}

template<typename t>
ostream& operator<<(ostream& os, CR(vector<t>) v) {rep(i,0,v.size())os<<v[i]<<' ';return os;}
ostream& operator<<(ostream& os, CR(pii) p) {return os<<"("<<FI(p)<<", "<<SE(p)<<")";}

vi high(vi u) {rep(i,0,u.size())u[i]++;return u;}
vi  low(vi u) {rep(i,0,u.size())u[i]--;return u;}

vvi fund(vi lambda) {
	vvi rt(lambda.size());
	int k = 1;
	rep(i,0,lambda.size()) {
		rep(T,0,lambda[i])
			rt[i].PB(k++);
	}
	return rt;
}

int size(const vvi&T) {
	int rt = 0;
	rep(i,0,T.size())
		rt += T[i].size();
	return rt;
}

map<int, pii> inv(const vvi &T) {
	map<int, pii> rt;
	rep(i,0,T.size())rep(j,0,T[i].size()) rt[T[i][j]]=MP(i,j);
	return rt;
}

void print(vvi T) {
	rep(i,0,T.size()) {
		rep(j,0,T[i].size()) 
			cout << T[i][j] << ' ';
		cout << endl;
	}		
}


string name(const vvi& T,string s="N",string c="v",string d="w") {
	ostringstream os;
	os << s;
	rep(i,0,T.size()) {
		rep(j,0,T[i].size())
			if(j == T[i].size()-1)
				os << T[i][j] << c;
			else
				os << T[i][j] << d;
	}
	return os.str();
}

int n = 4;

vi mult(vi w) {
	vi rt(n);rep(i,0,n) rt[i] = i;reverse(rt.begin(),rt.end());
	rep(i,0,w.size()) swap(rt[w[i]], rt[w[i]+1]);
	return rt;
}

void dfs(vi w) { //find all reduced expressions for w (interpreted as word in S*)
	vi p = mult(w);	
	bool is_id = true;
	rep(i,0,n-1) {
		if(p[i] > p[i+1]) {
			is_id = false;
			w.push_back(i);
			dfs(w);
			w.pop_back();
		}
	}
	if(is_id) {
		cout << high(w) << endl;
	}
}

int element(CR(vvi)T,int i,int j) {
	if(i < T.size() && i >= 0 && 0 <= j && j < T[i].size()) {
		return T[i][j];
	}
	return -1;
}


int path_i[100], path_j[100];
int array[100][100];

void promotion(vvi& T) {
	pii P = inv(T)[(n*(n+1))/2];
	int i = FI(P), j=SE(P);
	while(!(i == 0 && j == 0)) {
		if(element(T, i - 1, j) > element(T, i, j-1))	swap(T[i][j], T[i-1][j]), --i;	
		else swap(T[i][j], T[i][j-1]), --j;	
	}
	T[0][0] = 0;rep(i,0,T.size())rep(j,0,T[i].size())T[i][j]++;
}

vi staircase(int n) {
	vi rt;for(int l = n; l >= 1; --l) rt.PB(l);return rt;
}

vi seq(vvi T) {
	vi rt;
	int M = n*(n+1)/2;
	rep(tiden,0,M) {	
		for(int k = 0; k < n; ++k) {
			if(T[n-1-k][k] == M) {
				rt.PB(k);
				break;
			}
		}
		promotion(T);
	}
	reverse(rt.begin(), rt.end());
	return high(rt);
}

void SYT_dfs(int k, vi mu, vi lambda) {
	if(mu == lambda) {
		vvi T;
		for(int a=0;a<50;++a)for(int b=0;b<50;++b)array[a][b] =-1;
		for(int l = 1; l < k; ++l)
			array[path_i[l]][path_j[l]] = l;
		for(int i = 0; array[i][0] != -1; ++i) {
			T.push_back(vi());
			for(int j = 0; array[i][j] != -1; ++j) {
				T[i].push_back(array[i][j]);
			}
		}
		cout << seq(T) << endl;
		return;
	}

	rep(i,0,mu.size()) {
		if(mu[i] < lambda[i] && (i == 0 || mu[i] < mu[i-1])) {
			path_i[k] = i, path_j[k] = mu[i];
			mu[i]++;
			SYT_dfs(k+1,mu,lambda);
			mu[i]--;
		}
	}
	if(mu.size() < lambda.size()) {
		path_i[k] = mu.size(), path_j[k] = 0;
		mu.push_back(1);
		SYT_dfs(k+1,mu,lambda);
		mu.pop_back();
	}
}

int main(int argc, char**argv) {

	vi w;dfs(w);

	cout << " and " << endl;

	n = 3;
	SYT_dfs(1, vi(), staircase(n));

	cout << " are the same!" << endl;
	return 0;	
}
